package test.article2.recs.plugins.energy;

import schedframe.events.scheduling.EventReason;
import schedframe.resources.computing.profiles.energy.EnergyEvent;
import schedframe.resources.computing.profiles.energy.airthroughput.StandardAirflowStateName;
import schedframe.resources.devices.PhysicalResource;
import schedframe.scheduling.manager.tasks.JobRegistry;
import example.energy.BaseEnergyEstimationPlugin;

public class FanEnergyEstimationPlugin extends BaseEnergyEstimationPlugin {

	public double estimatePowerConsumption(EnergyEvent event, JobRegistry jobRegistry,
			PhysicalResource resource) {
		double powerConsumption = 0;
		try {
			if(event.getReason() == EventReason.SIM_INIT)
				powerConsumption = powerConsumption + resource.getAirflowInterface().getPowerConsumption(StandardAirflowStateName.OFF);
			else
				powerConsumption = powerConsumption + resource.getAirflowInterface().getPowerConsumption(resource.getAirflowInterface().getAirflowState());
		} catch (NoSuchFieldException e) {
		}

		return powerConsumption;
	}

	public double estimateAirflow(EnergyEvent event, JobRegistry jobRegistry, PhysicalResource resource) {
		double airflow = 0;
		try {
			if(event.getReason() == EventReason.SIM_INIT)
				airflow = resource.getAirflowInterface().getAirflow(StandardAirflowStateName.OFF);
			else
				airflow = resource.getAirflowInterface().getAirflow(resource.getAirflowInterface().getAirflowState());
		} catch (NoSuchFieldException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return airflow;
	}
}
